package cn.ibizlab.humanresource.core.humanresource.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.humanresource.core.humanresource.domain.HREmployee;
import cn.ibizlab.humanresource.core.humanresource.filter.HREmployeeSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[HREmployee] 服务对象接口
 */
public interface IHREmployeeService extends IService<HREmployee>{

    boolean create(HREmployee et) ;
    void createBatch(List<HREmployee> list) ;
    boolean update(HREmployee et) ;
    void updateBatch(List<HREmployee> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    HREmployee get(String key) ;
    HREmployee getDraft(HREmployee et) ;
    boolean checkKey(HREmployee et) ;
    boolean save(HREmployee et) ;
    void saveBatch(List<HREmployee> list) ;
    Page<HREmployee> searchAfterProbation(HREmployeeSearchContext context) ;
    Page<HREmployee> searchDefault(HREmployeeSearchContext context) ;
    Page<HREmployee> searchLeaveDuty(HREmployeeSearchContext context) ;
    Page<HREmployee> searchNoContract(HREmployeeSearchContext context) ;
    Page<HREmployee> searchOnDuty(HREmployeeSearchContext context) ;
    Page<HREmployee> searchWaitDuty(HREmployeeSearchContext context) ;
    List<HREmployee> selectByOrganizationid(String organizationid) ;
    void removeByOrganizationid(String organizationid) ;
    List<HREmployee> selectByEmpstate(String hrempstateid) ;
    void removeByEmpstate(String hrempstateid) ;
    List<HREmployee> selectByHrpostid(String hrpostid) ;
    void removeByHrpostid(String hrpostid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<HREmployee> getHremployeeByIds(List<String> ids) ;
    List<HREmployee> getHremployeeByEntities(List<HREmployee> entities) ;
}


